/*
    ftremote - remote serial/bitbang for FT232 and similar chips
    Copyright (C) 2002-2009  Ladislav Vaiz <ok1zia@nagano.cz>
    and authors of web browser Links 0.96

    This program is free software; you can redistribute it and/or                                                        
    modify it under the terms of the GNU General Public License                                                          
    version 2 as published by the Free Software Foundation.

*/

#ifndef __HEADER_H
#define __HEADER_H

#define HAVE_SDLDYNx

/*#ifdef HAVE_LIBFTDI_STATIC
#include "../libglib2/glib.h"
#include "../libglib2/gprintf.h"
#else
#include <glib.h>
#include <glib/gprintf.h>
#endif
*/

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif

#ifndef __USE_POSIX 
#define __USE_POSIX
#endif
#ifndef __USE_POSIX2
#define __USE_POSIX2
#endif
#ifndef __USE_MISC
#define __USE_MISC
#endif
#ifndef __USE_BSD
#define __USE_BSD
#endif
#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#ifndef __USE_GNU
#define __USE_GNU
#endif

#ifdef HAVE_MATH_H
#include <math.h>
#endif
 
#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#endif

#include <stdio.h>


#include <stdlib.h>
#include <stdarg.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <ctype.h>
#include <string.h>
#include <errno.h>
#ifdef HAVE_LIMITS_H
#include <limits.h>
#endif
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>


#ifdef TIME_WITH_SYS_TIME
#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif
#ifdef HAVE_TIME_H
#include <time.h>
#endif
#else
#if defined(TM_IN_SYS_TIME) && defined(HAVE_SYS_TIME_H)
#include <sys/time.h>
#elif defined(HAVE_TIME_H)
#include <time.h>
#endif
#endif

#include <sys/stat.h>
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif
#ifdef HAVE_DIRENT_H
#include <dirent.h>
#endif
#include <signal.h>
#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif
#ifdef HAVE_SYS_SELECT_H
#include <sys/select.h>
#endif
#include <sys/wait.h>

#ifdef HAVE_NETINET_IN_SYSTM_H
#include <netinet/in_systm.h>
#else
#ifdef HAVE_NETINET_IN_SYSTEM_H
#include <netinet/in_system.h>
#endif
#endif
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <utime.h>

#include <pwd.h>
#include <grp.h>
#include <regex.h>


#ifdef __CYGWIN__
#include <windows.h>
#endif


#ifdef HAVE_STDINT_H
#include <stdint.h>
#endif


/*#ifdef __GLIBC__
#include <gnu/libc-version.h>
#endif*/


#ifdef HAVE_LONG_LONG
#define longlong long long
#else
#define longlong long
#endif

/* integer type same size as void *   */
#undef vint
#if SIZEOF_SHORT == SIZEOF_VOID_P
typedef short vint;
#elif SIZEOF_INT == SIZEOF_VOID_P
typedef int vint;
#elif SIZEOF_LONG == SIZEOF_VOID_P
typedef long vint;
#elif defined(HAVE_LONG_LONG) && SIZEOF_LONG_LONG == SIZEOF_VOID_P
typedef long long vint;
#else
#error You have no integer type of size void *
#endif

#include <termios.h>

#ifdef HAVE_GETOPT_H
#include <getopt.h>
#endif


#ifdef HAVE_LIBFTDI_STATIC
#include "../libftdi/ftdi.h"
#else
#ifdef HAVE_LIBFTDI
#include <ftdi.h>
#endif
#endif


#define DUMMY ((void *)-1L)


int fileno(FILE *stream);


struct conn;
union cba_t{
    char *charp;
    void *void_;
    int int_;
    struct conn *conn;
};

#define CBA0 ((union cba_t)0)

#ifdef LEAK_DEBUG_LIST
#define LOCK(x) { \
    g_mutex_lock(x##_mutex); \
    x##_file = __FILE__; \
    x##_line = __LINE__; \
}
#define UNLOCK(x) g_mutex_unlock(x##_mutex)
#else
#define LOCK(x) g_mutex_lock(x##_mutex)
#define UNLOCK(x) g_mutex_unlock(x##_mutex)

#endif

/*#define LOCK(x)    dbg("   lock %p %s:%d\n", x##_mutex, __FILE__, __LINE__); g_mutex_lock(x##_mutex)
#define UNLOCK(x)  dbg(" unlock %p %s:%d\n", x##_mutex, __FILE__, __LINE__); g_mutex_unlock(x##_mutex)
  */

#if 0
/* ghash.c */

typedef void* gpointer;
typedef void const * gconstpointer;
typedef int gint;
typedef unsigned int guint;
typedef gint gboolean;
typedef char gchar;
typedef guint (*GHashFunc)(gconstpointer  key);
typedef gint (*GCompareDataFunc)(gconstpointer a, gconstpointer b, gpointer user_data);
typedef gint (*GCompareFunc)(gconstpointer  a, gconstpointer  b);
typedef void (*GHFunc)(gpointer key, gpointer value,  gpointer user_data);
typedef gboolean (*GHRFunc)(gpointer key, gpointer value, gpointer user_data);

typedef struct _THashNode      THashNode;
typedef struct _THashTable     THashTable;

struct _THashNode
{
  gpointer key;
  gpointer value;
  THashNode *next;
};

struct _THashTable
{
  gint size;
  gint nnodes;
  guint frozen;
  THashNode **nodes;
  GHashFunc hash_func;
  GCompareFunc key_compare_func;
};

void init_ghash(void);
void free_ghash(void);
THashTable *t_hash_table_new (GHashFunc hash_func, GCompareFunc key_compare_func);
void t_hash_table_destroy (THashTable *hash_table);
void t_hash_table_foreach (THashTable *hash_table, GHFunc func, gpointer user_data);
void t_hash_table_insert (THashTable *hash_table, gpointer key, gpointer value);
void t_hash_table_remove (THashTable *hash_table, gconstpointer key);
gpointer t_hash_table_lookup (THashTable *hash_table, gconstpointer key);
gboolean t_hash_table_lookup_extended (THashTable *hash_table, gconstpointer lookup_key, gpointer *orig_key, gpointer *value);
guint t_hash_table_foreach_remove (THashTable *hash_table, GHRFunc func, gpointer user_data);
guint t_hash_table_size (THashTable *hash_table);

guint t_direct_hash(gconstpointer v);
gboolean t_direct_equal (gconstpointer v, gconstpointer v2);

#endif
/* error.c */

extern int debug_type;
extern char *debug_filename;

void do_not_optimize_here(void *p);
void check_memory_leaks(void);
void error(char *, ...);
void debug_msg(char *, ...);
void internal_error( char *, ...);

void init_debug(void);
void free_debug(void);
void dbg(char *m, ...);

//id dbg_str_hash(THashTable *hash);
extern int errline;
extern char *errfile;

#define internal errfile = __FILE__, errline = __LINE__, internal_error
#define debug errfile = __FILE__, errline = __LINE__, debug_msg

#define xmalloc malloc
#define xfree free
#define xrealloc realloc


/*#endif*/

#ifdef LEAK_DEBUG

extern long mem_amount;
extern long last_mem_amount;

#ifndef LEAK_DEBUG_LIST
struct alloc_header {
    int size;
};
#else
struct alloc_header {
    struct alloc_header *next;
    struct alloc_header *prev;
    int size;
    int line;
    char *file;
    char *comment;
};
#endif

#define L_D_S ((sizeof(struct alloc_header) + 7) & ~7)

#endif

#ifdef LEAK_DEBUG

void *debug_mem_alloc(char *, int, size_t);
void debug_mem_free(char *, int, void *);
void *debug_mem_realloc(char *, int, void *, size_t);
void set_mem_comment(void *, char *, int);
void *debug_g_new0(char *, int, size_t);
void *debug_g_new(char *, int, size_t);
gchar *debug_g_strdup(char *, int, const gchar *);
gchar *debug_g_strndup(char *, int, gchar *, gint);
gchar *debug_g_strdup_printf(char *, int, gchar *, ...);
gchar *debug_g_strdup_vprintf(char *, int, gchar *, va_list args);
gchar *debug_g_strconcat(char *, int, ...);

#define mem_alloc(x) debug_mem_alloc(__FILE__, __LINE__, x)
#define mem_free(x) debug_mem_free(__FILE__, __LINE__, x)
#define mem_realloc(x, y) debug_mem_realloc(__FILE__, __LINE__, x, y)
#undef g_new0
#define g_new0(x, y) debug_g_new0(__FILE__, __LINE__, sizeof(x)* y)        
#undef g_new
#define g_new(x, y) debug_g_new0(__FILE__, __LINE__, sizeof(x)* y)        
#define g_free(x) debug_mem_free(__FILE__, __LINE__, x)
#define g_realloc(x, y) debug_mem_realloc(__FILE__, __LINE__, x, y)
#define g_strdup(x) debug_g_strdup(__FILE__, __LINE__, x) 
#define g_strndup(x,y) debug_g_strndup(__FILE__, __LINE__, x, y) 
#define g_strdup_printf(x...) debug_g_strdup_printf(__FILE__, __LINE__, x) 
#define g_strdup_vprintf(x, y) debug_g_strdup_vprintf(__FILE__, __LINE__, x, y) 
#define g_strconcat(x...) debug_g_strconcat(__FILE__, __LINE__, x) 


#else

static inline void *mem_alloc(size_t size)
{
    void *p;
    if (!size) return DUMMY;
    if (!(p = malloc(size))) {
        error("ERROR: out of memory (malloc returned NULL)\n");
        return NULL;
    }
    return p;
}

static inline void mem_free(void *p)
{
    if (p == DUMMY) return;
    if (!p) {
        internal("mem_free(NULL)");
        return;
    }
    free(p);
}

static inline void *mem_realloc(void *p, size_t size)
{
    if (p == DUMMY) return mem_alloc(size);
    if (!p) {
        internal("mem_realloc(NULL, %d)", size);
        return NULL;
    }
    if (!size) {
        mem_free(p);
        return DUMMY;
    }
    if (!(p = realloc(p, size))) {
        error("ERROR: out of memory (realloc returned NULL)\n");
        return NULL;
    }
    return p;
}

static inline void *debug_mem_alloc(char *f, int l, size_t s) { return mem_alloc(s); }
static inline void debug_mem_free(char *f, int l, void *p) { mem_free(p); }
static inline void *debug_mem_realloc(char *f, int l, void *p, size_t s) { return mem_realloc(p, s); }
static inline void set_mem_comment(void *p, char *c, int l) {}

#endif

static inline char upcase(char a)
{
    if (a>='a' && a<='z') a -= 0x20;
    return a;
}

static inline char lowcase(char a)
{
    if (a>='A' && a<='Z') a += 0x20;
    return a;
}

static inline char *lc(char *str){
    char *c;
    
    if (!str) return str;
    c=str;
    while (*c!='\0'){
        if (*c>='A' && *c<='Z') *c+=0x20;
        c++;
    }
    return str;
}

static inline char *uc(char *str){
    char *c;
    
    if (!str) return str;
    c=str;
    while (*c!='\0'){
        if (*c>='a' && *c<='z') *c-=0x20;
        c++;
    }
    return str;
}

static inline char *fixsemi(char *str){
    char *c;
    
    if (!str) return str;
    c=str;
    while (*c!='\0'){
        if (*c==';') *c=':';
        c++;
    }
    return str;
} 


#if !(defined(LEAK_DEBUG) && defined(LEAK_DEBUG_LIST))

static inline char *memacpy(const char *src, int len)
{
    char *m;
    if ((m = mem_alloc(len + 1))) {
        memcpy(m, src, len);
        m[len] = 0;
    }
    return m;
}

static inline char *stracpy(const char *src)
{
    return src ? memacpy(src, src != DUMMY ? strlen(src) : 0) : NULL;
}

#else

static inline char *debug_memacpy(char *f, int l, char *src, int len)
{
    char *m;
    if ((m = debug_mem_alloc(f, l, len + 1))) {
        memcpy(m, src, len);
        m[len] = 0;
    }
    return m;
}

#define memacpy(s, l) debug_memacpy(__FILE__, __LINE__, s, l)

static inline char *debug_stracpy(char *f, int l, char *src)
{
    return src ? debug_memacpy(f, l, src, src != DUMMY ? strlen((char*)src) : 0) : NULL;
}

#define stracpy(s) debug_stracpy(__FILE__, __LINE__, s)

#endif
  
static inline int snprint(char *s, int n, unsigned num)
{
    int q = 1;
    while (q <= num / 10) q *= 10;
    while (n-- > 1 && q) *(s++) = num / q + '0', num %= q, q /= 10;
    *s = 0;
    return !!q;
}

static inline int snzprint(char *s, int n, int num)
{
    if (n > 1 && num < 0) *(s++) = '-', num = -num, n--;
    return snprint(s, n, num);
}

static inline void add_to_strn(char **s, char *a)
{
    char *p;
    if (!(p = mem_realloc(*s, strlen(*s) + strlen(a) + 1))) return;
    strcat(p, a);
    *s = p;
}

#define ALLOC_GR    0x100       /* must be power of 2 */

#define init_str() init_str_x(__FILE__, __LINE__)

static inline char *init_str_x(char *file, int line)
{
    char *p;
    if ((p = debug_mem_alloc(file, line, ALLOC_GR))) *p = 0;
    return p;
}

static inline void add_to_str(char **s, int *l, char *a)
{
    char *p;
    int ll = strlen(a);
    if ((*l & ~(ALLOC_GR - 1)) != ((*l + ll) & ~(ALLOC_GR - 1)) &&
       (!(p = mem_realloc(*s, (*l + ll + ALLOC_GR) & ~(ALLOC_GR - 1))) ||
       !(*s = p))) return;
    strcpy(*s + *l, a); *l += ll;
}


static inline void add_chr_to_str(char **s, int *l, char a)
{
    char *p;
    if ((*l & (ALLOC_GR - 1)) == ALLOC_GR - 1 &&
       (!(p = mem_realloc(*s, (*l + 1 + ALLOC_GR) & ~(ALLOC_GR - 1))) ||
       !(*s = p))) return;
    *(*s + *l) = a; *(*s + ++(*l)) = 0;
}

static inline void add_num_to_str(char **s, int *l, int n)
{
    char a[64];
    snzprint(a, 64, n);
    add_to_str(s, l, a);
}


static inline char *safe_strncpy(char *dst, const char *src, size_t dst_size) {
    strncpy(dst, src, dst_size);
    if (strlen(src) >= dst_size) dst[dst_size - 1] = 0;
    return dst;
}


static inline char *safe_strncpy0(char *dst, const char *src, size_t dst_size) {
    if (!src) {
        *dst='\0';
        return dst;
    }

    strncpy(dst, src, dst_size);
    if (strlen(src) >= dst_size) dst[dst_size - 1] = 0;
    return dst;
}





#define STRERR(no) strerror_r(no, errbuf, sizeof(errbuf))

struct list_head {
    void *next;
    void *prev;
};

#ifndef HAVE_TYPEOF

struct xlist_head {
    struct xlist_head *next;
    struct xlist_head *prev;
};

#endif

#define init_list(x) {(x).next=&(x); (x).prev=&(x);}
#define list_empty(x) ((x).next == &(x))
#define del_from_list(x) {((struct list_head *)(x)->next)->prev=(x)->prev; ((struct list_head *)(x)->prev)->next=(x)->next;}
#define add_at_pos(p,x) do {(x)->next=(p)->next; (x)->prev=(p); (p)->next=(x); (x)->next->prev=(x);} while(0)

#ifdef HAVE_TYPEOF
#define add_to_list(l,x) add_at_pos((typeof(x))&(l),(x))
#define foreach(e,l) for ((e)=(l).next; (e)!=(typeof(e))&(l); (e)=(e)->next)
#define foreachback(e,l) for ((e)=(l).prev; (e)!=(typeof(e))&(l); (e)=(e)->prev)
#else
#define add_to_list(l,x) add_at_pos((struct xlist_head *)&(l),(struct xlist_head *)(x))
#define foreach(e,l) for ((e)=(l).next; (e)!=(void *)&(l); (e)=(e)->next)
#define foreachback(e,l) for ((e)=(l).prev; (e)!=(void *)&(l); (e)=(e)->prev)
#endif
#define free_list(l) {while ((l).next != &(l)) {struct list_head *a=(l).next; del_from_list(a); mem_free(a); }}


static inline int casecmp(char *c1, char *c2, int len)
{
    int i;
    for (i = 0; i < len; i++) if (upcase(c1[i]) != upcase(c2[i])) return 1;
    return 0;
}

static inline int can_write(int fd)
{
    fd_set fds;
    struct timeval tv = {0, 0};
    FD_ZERO(&fds);
    FD_SET(fd, &fds);
    return select(fd + 1, NULL, &fds, NULL, &tv);
}

static inline int can_read(int fd)
{
    fd_set fds;
    struct timeval tv = {0, 0};
    FD_ZERO(&fds);
    FD_SET(fd, &fds);
    return select(fd + 1, &fds, NULL, NULL, &tv);
}




/* select.c */

#ifndef FD_SETSIZE
#define FD_SETSIZE 1024
#endif

typedef long ttime;
typedef unsigned tcount;

extern int terminate;

/*long select_info(int);*/
void select_loop(void (*)(void));
int register_bottom_half(void (*)(union cba_t), union cba_t cba);
void check_bottom_halves(void);
#ifdef LEAK_DEBUG_LIST
int debug_install_timer(char *file, int line, ttime, void (*)(union cba_t), union cba_t cba); /* todo argument callbacku */
#define install_timer(x, y, z) debug_install_timer(__FILE__, __LINE__, x, y, z)
void debug_kill_timer(char *file, int line, int timer_id);
#define kill_timer(x) debug_kill_timer(__FILE__, __LINE__, x)
void debug_set_handlers(char *file, int line, int, void (*)(union cba_t), void (*)(union cba_t), void (*)(union cba_t), union cba_t cba);
#define set_handlers(n, r, w, x, a) debug_set_handlers(__FILE__, __LINE__, n, r, w, x, a);
#else
int install_timer(ttime, void (*)(union cba_t), union cba_t cba); /* todo argument callbacku */
void kill_timer(int);
void set_handlers(int, void (*)(union cba_t), void (*)(union cba_t), void (*)(union cba_t), union cba_t cba);
#endif
ttime get_timer_time(int);
ttime get_time(void);


#define H_READ  0
#define H_WRITE 1
#define H_ERROR 2
#define H_DATA  3

void *get_handler(int, int);
void install_signal_handler(int, void (*)(union cba_t), union cba_t, int);
void set_sigcld(void);

extern struct timeval start;
#define ST_START gettimeofday(&start, NULL)
#define ST_STOP {\
    struct timeval stop;\
    int sec, usec;\
    gettimeofday(&stop, NULL);\
    usec=stop.tv_usec-start.tv_usec;\
    sec=stop.tv_sec-start.tv_sec;\
    if (usec<0){usec+=1000000;sec--;}\
    dbg("stopky: %s: %d.%06d \n", __FUNCTION__, sec,usec);\
}

/* tcp.c */

#define MAXRDBUF 1024
#define MAXWRBUF 1024
/* milliseconds */
#define CONNECTION_TIMEOUT 30000
#define SEND_ACK_TIMEOUT 10000
#define ACK_TIMEOUT 20000
#define REMOVE_TIMEOUT 10000

enum tcp_state { 
    TCP_INIT=0, 
    TCP_CONNECTING,
    TCP_CONNECTED,
    TCP_DISCONNECTED,
    TCP_DEAD,  /* conn removed immediately */
};

struct conn {
    int sock; 
    enum tcp_state state;
    struct sockaddr_in sin;
    int timer;
  /*  char rdbuf[MAXRDBUF];
    int rdbuflen;
    char wrbuf[MAXWRBUF];
    int wrbuflen;*/
    int disconnecting;
};

extern struct conn *conn;

int init_tcp();
void tcp_accept_handler(union cba_t cba);
void tcp_connect(char *hostname, int port);
void tcp_connected_handler(union cba_t cba);
void after_connect(struct conn *conn);
void tcp_disconnect(struct conn *conn, char *reason);
void tcp_read_handler(union cba_t cba);
void tcp_exception_handler(union cba_t cba);
int tcp_send_state(struct conn *conn);
//void tcp_set_state(struct conn *conn, enum tcp_state state);
//char *tcp_state_s(enum tcp_state state);
void kill_conn_timer(void *xxx);
void remove_conn_timer(void *xxx);
void free_conn(struct conn *conn);
void tcp_write_handler(void *xxx);

/* main.c */

#define RET_OK      0
#define RET_ERROR   1
#define RET_SIGNAL  2
#define RET_SYNTAX  3
#define RET_FATAL   4
extern int retval;
extern int first_use;
extern int first_contest_def;

extern char *path_to_exe;

void unhandle_terminal_signals(void);
void unhandle_basic_signals(void);
int term_attach_terminal(int, int, int);
void shrink_memory(int);
void handle_basic_signals(void);
void sig_segv(union cba_t cba);





/* rc.c */

extern struct rcitem cfg;

struct rcitem {
    struct rcitem *next;  
    struct rcitem *prev;
	char *key;
	char *value;
};

extern int opt_d, opt_g, opt_h, opt_i, opt_s, opt_t, opt_r, opt_w, debug_keyboard;
extern char *opt_hostname;

int init_rc(void);
int free_rc(void);
int read_rc_file(char *filename);
int read_rc_files(void);
//void save_rc_string(GString *gs); 
int save_rc_file(char *filename);
char *parse_options(int argc, char **argv);


char *rc_getopt(char *key);
char *rc_str(char *key, char *def);
int rc_int(char *key, int def);
int rc_double(char *key, double def);
void rc_info(void);

/* ftdi.c */

extern struct ftdi_context *ftdi;
extern int ftdi_force_send;

int init_ftdi();
int ftdi_open(int verbose);
void ftdi_dummy_timer_read(union cba_t cba);
void ftdi_timer_read(union cba_t cba);

#ifndef HAVE_FTDI_NEW
struct ftdi_context *ftdi_new(void);
void ftdi_free(struct ftdi_context *ftdi);
#endif

void usb_info(void);
unsigned short ftdi_checksum(unsigned char *eeprom, int eeprom_size);


	

  /* settings.c */
extern char *txt_settings;


/* help */
extern char *help;

#endif /* __HEADER_H */     
